/**
 * A an example main method for simulating a Guitar.
 */
public class GuitarPlayerLite
{
    public static void main(String[] args) 
    {
        double CONCERT_A = 440.0; //frequency of a Concert A
        double CONCERT_C = CONCERT_A * Math.pow(2, 3.0/12.0); //frequency of a Concert C

        //create two guitar strings, for concert A and C
        GuitarString stringA = new GuitarString(CONCERT_A);
        GuitarString stringC = new GuitarString(CONCERT_C);

        IOFrame frame = new IOFrame("Guitar Heroine Lite", 600, 150); //an interaction window to use. Make sure it has focus to type in it!

        while(true) //continually process input
        {
            if(frame.hasMoreKeysTyped()) //check if there has been a key pressed recently 
            {
                char key = frame.getNextKeyTyped(); //find out which key
                System.out.println("You pressed '"+key+"'");

                //pluck a string based on that key
                if(key == 'a') 
                { 
                    stringA.pluck(); 
                }
                else if(key == 'c') 
                { 
                    stringC.pluck(); 
                }
            }

            //compute the superposition of samples (the sum of all sound)
            double sample = stringA.sample() + stringC.sample();

            //play the sample on standard audio ((a provided static class))
            StdAudio.play(sample);

            //advance the simulation of each guitar string by one step
            stringA.update();
            stringC.update();
        }
    }
}
