/**
 * A Tester for the GuitarString Karplus-Strong algorithm
 *
 * @author Adapted from UPenn.
 */
public class GuitarStringTester
{
    public static void main(String[] args) 
    {
        //tests the Karplus-Strong algorithm by applying a known set of samples (rather than a random plucking).
        //Outputted valus should look like:
        //      0   0.2000
        //      1   0.4000
        //      2   0.5000
        //      3   0.3000
        //      4  -0.2000
        //      5   0.4000
        //      6   0.3000
        //      7   0.0000
        //      8  -0.1000
        //      9  -0.3000
        //     10   0.2982
        //     11   0.4473
        //     12   0.3976
        //     13   0.0497
        //     14   0.0994
        //     15   0.3479
        //     16   0.1491
        //     17  -0.0497
        //     18  -0.1988
        //     19  -0.0009
        //     20   0.3705
        //     21   0.4199
        //     22   0.2223
        //     23   0.0741
        //     24   0.2223
        
        double[] samples = { .2, .4, .5, .3, -.2, .4, .3, .0, -.1, -.3 };  
        GuitarString testString = new GuitarString(samples);
        for (int i = 0; i < 25; i++) {
            double sample = testString.sample();
            System.out.printf("%6d %8.4f\n", i, sample);
            testString.update();
        }
    }
}
